#ifndef _LISTA_H_
#define _LISTA_H_

#include "Elemento.h"

template<class TIPO>
class Lista
{
private:
    Elemento<TIPO>*  pPrimeiro;
    Elemento<TIPO>*  pAtual;

	char nome [150];

public:

    Lista ( );
    ~Lista ( );
    void inicializa ( );
    bool incluaElemento ( Elemento<TIPO>* pElemento );
    bool incluaInfo ( TIPO* pInfo, char* nome = "" );
    void listeInfos ( );

	TIPO* localizar(char* n);

	void setNome(char* n);
	char* getNome();

	Elemento<TIPO>* getPrimeiro()	{ return pPrimeiro;	}
	Elemento<TIPO>* getAtual()		{ return pAtual;	}

};

template<class TIPO>
Lista<TIPO>::Lista ( )
{
    inicializa ( );
}

template<class TIPO>
Lista<TIPO>::~Lista ( )
{
}

template<class TIPO>
void Lista<TIPO>::inicializa ( )
{
     pPrimeiro = NULL;
     pAtual    = NULL;
}

template<class TIPO>
bool Lista<TIPO>::incluaElemento ( Elemento<TIPO>* pElemento )
{
    if (NULL != pElemento)
    {

       if (NULL == pPrimeiro)
       {
          pPrimeiro = pElemento;
          pPrimeiro->setAnterior ( NULL );
          pPrimeiro->setProximo ( NULL );
          pAtual = pPrimeiro;
      }
      else
      {
          pElemento->setAnterior ( pAtual );
          pElemento->setProximo ( NULL );
          pAtual->setProximo ( pElemento );
          pAtual = pAtual->getProximo ( ); 
      }
      return true;
    }
    else
    {
        cout << "Erro, elemento nulo na lista." << endl;
        return false;
    }
}

template<class TIPO>
bool Lista<TIPO>::incluaInfo ( TIPO *pInfo, char* nome )
{
     if (NULL != pInfo)
     {
          Elemento<TIPO>* pElemento;
          pElemento = new Elemento<TIPO>();
          pElemento->setNome (nome);
          pElemento->setInfo (pInfo);
          incluaElemento (pElemento);
          return true;
     }
     else
     {
          printf ( "Erro, elemento (informao) nulo(a) na lista. \n" );
          return false;
     }
}

template<class TIPO>
void Lista<TIPO>::listeInfos()
{
    Elemento<TIPO>* paux;
    paux = pPrimeiro;

    if (NULL != pPrimeiro)
    {
         while (NULL != paux)
         {
              printf ( "Elemento na lista %s \n", paux->getNome() );
              paux = paux->getProximo();
         }
    }
}

template<class TIPO>
TIPO* Lista<TIPO>::localizar(char* n)
{
	Elemento<TIPO>* paux;
    paux = pPrimeiro;
    while (paux != NULL)
    {
		if (0 == strcmp(n, paux->getNome()))
		{
			return paux->getInfo();
		}
        paux = paux->getProximo();
    }
	return NULL;
}

template<class TIPO>
void Lista<TIPO>::setNome(char* n)
{
	strcpy(nome, n);
}

template<class TIPO>
char* Lista<TIPO>::getNome()
{
	return nome;
}


#endif
